/*
* The ScummVM WPF UI project
* Net Wrapper for WPF UI
*
* Copyright (c) 2016 MojoTouch
* Author: Ilya Rovensky
*/

#pragma once

#include <msclr\auto_gcroot.h>

namespace NetWrapper {
	using namespace System;
	using namespace System::Collections::Generic;
	using namespace WpfInterface;

	// C++/CLI data types container
	class ManagedWrapper
	{
	public:
		ManagedWrapper();

		MenuAction ShowMenu(MenuAction menuAction, int menuState);
		void DisplayMainMenu(int menuState);
		int ShowSettings(MenuAction menuAction, List<Setting^>^ settings);
		void HideMenu();
		//void ShowTutorial();
		int ShowDialog(String^ message, List<String^>^ buttons);
		int ShowDialogWithList(String^ message, List<String^>^ items, int buttonCount, String^ negativeButton, String^ positiveButton);
		int ShowDialogWithInput(String^ message, String^% input, String^ positiveButton, String^ negativeButton);
		void ShowProgressDialog(String^ message);
		void HideProgressDialog();
		void ShowNotification(String^ message);
		bool HasTouchInput();
		void InitStrings(List<String^>^ strings, int gameToPromote, String^ urlToPromote, String^ urlToRate);
		bool IsShowingMenu();
		void SetOglWindowHandle(IntPtr handle);
		String^ QueryUrl(String^ url);

	private:
		msclr::auto_gcroot<UserInterface^> userInterface;
	};
}