﻿#region Copyright
/// <summary>The ScummVM WPF UI project</summary>
/// <copyright>(c) 2016 MojoTouch</copyright>
/// <author>Ilya Rovensky</author>
#endregion

using System;
using System.IO;
using System.Windows.Media;

namespace WpfInterface
{
    public static class SoundPlayer
    {
        private static MediaPlayer _clickPlayer;
        private static MediaPlayer _musicPlayer;

        static SoundPlayer()
        {
            _clickPlayer = new MediaPlayer();
            _musicPlayer = new MediaPlayer();
            _clickPlayer.MediaFailed += PlayerFailed;
            _musicPlayer.MediaFailed += PlayerFailed;
        }
        
        private static void PlayerFailed(object sender, ExceptionEventArgs e)
        {
            //File.AppendAllText("log.txt", $"{e.ErrorException.Message}\n");
            throw e.ErrorException;
        }

        public static void Click()
        {
            _clickPlayer.Open(new Uri($"{Assets.Path}/click.mp3", UriKind.Relative));
            _clickPlayer.Play();            
        }

        public static void Music(bool play)
        {
            if (play)
            {
                _musicPlayer.Open(new Uri($"{Assets.Path}/bgmusic.mp3", UriKind.Relative));

                // loop
                _musicPlayer.MediaEnded += (_, __) => 
                {
                    _musicPlayer.Position = TimeSpan.Zero;
                    _musicPlayer.Play();
                };

                _musicPlayer.Play();
            }
            else
                _musicPlayer.Stop();
        }
    }
}
